
function parseEBNF(str, fn) {
  str = '(' + str + ')';

  function expect(c) {
    if (accept(c)) return c;
    throw new Error('expected "' + c + '", got "' + str[0] + '"');
  }

  function accept(c) {
    if (c == str[0]) {
      str = str.substr(1);
      return c;
    }
  }

  function whitespace() {
    while (accept(' ')) ;
  }

  function match(s) {
    if (0 == str.indexOf(s)) {
      str = str.substr(s.length);
      return s;
    }
  }

  function group() {
    var tok
      , ret = ['group', []];
    whitespace();
    expect('(');
    while (tok = expr()) ret[1].push(tok);
    expect(')');
    return ret;
  }

  function expr() {
    var tok;
    whitespace();
    if (accept('(')) tok = group();
    else if (accept('[')) tok = option();
    else if (match('length')) tok = 'length';
    else if (accept('%')) tok = '%';
    whitespace();
    return tok;
  }

  function alternation() {
    var ret = ['or', []];
    do {
      ret[1].push(expr());
    } while (accept('|'));
    return ret;
  }

  function option() {
    var tok = ['option', alternation()];
    expect(']');
    return tok;
  }

  return group();
}

function inspectEBNF(str) {
  console.log(require('util').inspect(parseEBNF(str), false, 50, true));
}

// [ <length> | <%> ] [ <length> | <%> ]?


inspectEBNF('[ length | % ] [ length | % ]');
